searchData={"items":[{"type":"behaviour","title":"Comeonin","doc":"Defines a behaviour for higher-level password hashing functions.","ref":"Comeonin.html"},{"type":"callback","title":"Comeonin.add_hash/2","doc":"","ref":"Comeonin.html#c:add_hash/2"},{"type":"callback","title":"Comeonin.check_pass/3","doc":"","ref":"Comeonin.html#c:check_pass/3"},{"type":"callback","title":"Comeonin.no_user_verify/1","doc":"Runs the password hash function, but always returns false.\n\nThis function is intended to make it more difficult for any potential\nattacker to find valid usernames by using timing attacks. This function\nis only useful if it is used as part of a policy of hiding usernames.","ref":"Comeonin.html#c:no_user_verify/1"},{"type":"type","title":"Comeonin.opts/0","doc":"","ref":"Comeonin.html#t:opts/0"},{"type":"type","title":"Comeonin.password/0","doc":"","ref":"Comeonin.html#t:password/0"},{"type":"type","title":"Comeonin.user_struct/0","doc":"","ref":"Comeonin.html#t:user_struct/0"},{"type":"module","title":"Comeonin.BehaviourTestHelper","doc":"Test helper functions for Comeonin behaviours.","ref":"Comeonin.BehaviourTestHelper.html"},{"type":"function","title":"Comeonin.BehaviourTestHelper.add_hash_creates_map/2","doc":"Checks that the `add_hash/2` function creates a map with the `password_hash` set.","ref":"Comeonin.BehaviourTestHelper.html#add_hash_creates_map/2"},{"type":"function","title":"Comeonin.BehaviourTestHelper.ascii_passwords/0","doc":"List of passwords that just contain basic ascii characters.","ref":"Comeonin.BehaviourTestHelper.html#ascii_passwords/0"},{"type":"function","title":"Comeonin.BehaviourTestHelper.check_pass_nil_user/1","doc":"Checks that the `check_pass/3` function returns an error when no user is found.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_nil_user/1"},{"type":"function","title":"Comeonin.BehaviourTestHelper.check_pass_returns_error/2","doc":"Checks that the `check_pass/3` function returns an error for incorrect passwords.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_error/2"},{"type":"function","title":"Comeonin.BehaviourTestHelper.check_pass_returns_user/2","doc":"Checks that the `check_pass/3` function returns the user for correct passwords.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_user/2"},{"type":"function","title":"Comeonin.BehaviourTestHelper.correct_password_true/2","doc":"Checks that the `verify_pass/2` function returns true for correct password.","ref":"Comeonin.BehaviourTestHelper.html#correct_password_true/2"},{"type":"function","title":"Comeonin.BehaviourTestHelper.non_ascii_passwords/0","doc":"List of passwords that contain non-ascii characters.","ref":"Comeonin.BehaviourTestHelper.html#non_ascii_passwords/0"},{"type":"function","title":"Comeonin.BehaviourTestHelper.wrong_password_false/2","doc":"Checks that the `verify_pass/2` function returns false for incorrect passwords.","ref":"Comeonin.BehaviourTestHelper.html#wrong_password_false/2"},{"type":"behaviour","title":"Comeonin.PasswordHash","doc":"Defines a behaviour for password hashing functions.","ref":"Comeonin.PasswordHash.html"},{"type":"callback","title":"Comeonin.PasswordHash.hash_pwd_salt/2","doc":"Generates a random salt and then hashes the password.","ref":"Comeonin.PasswordHash.html#c:hash_pwd_salt/2"},{"type":"callback","title":"Comeonin.PasswordHash.verify_pass/2","doc":"Checks the password by comparing it with a stored hash.\n\nPlease note that the first argument to `verify_pass` should be the\npassword, and the second argument should be the password hash.","ref":"Comeonin.PasswordHash.html#c:verify_pass/2"},{"type":"type","title":"Comeonin.PasswordHash.opts/0","doc":"","ref":"Comeonin.PasswordHash.html#t:opts/0"},{"type":"type","title":"Comeonin.PasswordHash.password/0","doc":"","ref":"Comeonin.PasswordHash.html#t:password/0"},{"type":"type","title":"Comeonin.PasswordHash.password_hash/0","doc":"","ref":"Comeonin.PasswordHash.html#t:password_hash/0"},{"type":"extras","title":"Comeonin","doc":"# Comeonin\n\n[![Build Status](https://travis-ci.com/riverrun/comeonin.svg?branch=master)](https://travis-ci.com/riverrun/comeonin)\n[![Module Version](https://img.shields.io/hexpm/v/comeonin.svg)](https://hex.pm/packages/comeonin)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/comeonin/)\n[![Total Download](https://img.shields.io/hexpm/dt/comeonin.svg)](https://hex.pm/packages/comeonin)\n[![License](https://img.shields.io/hexpm/l/comeonin.svg)](https://github.com/riverrun/comeonin/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/riverrun/comeonin.svg)](https://github.com/riverrun/comeonin/commits/master)\n[![Join the chat at https://gitter.im/comeonin/Lobby](https://badges.gitter.im/comeonin/Lobby.svg)](https://gitter.im/comeonin/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)\n\nComeonin is a specification for password hashing libraries.\n\nFor information about hashing passwords in your app, see\n[Password hashing libraries](#password-hashing-libraries).","ref":"readme.html"},{"type":"extras","title":"Changes in version 5 - Comeonin","doc":"In version 5.0 and above, Comeonin now provides two behaviours, Comeonin and\nComeonin.PasswordHash, which password hash libraries then implement.\n\nWith these changes, Comeonin is now a dependency of the password hashing\nlibrary you choose to use, and in most cases, you will not use it\ndirectly.\n\nSee the [UPGRADE_v5 guide](https://github.com/riverrun/comeonin/blob/master/UPGRADE_v5.md)\nfor information about you can upgrade to version 5.","ref":"readme.html#changes-in-version-5"},{"type":"extras","title":"Password hashing libraries - Comeonin","doc":"The following libraries all implement the Comeonin and Comeonin.PasswordHash\nbehaviours:\n\n* Argon2 - argon2_elixir\n  * [docs](https://hexdocs.pm/argon2_elixir)\n  * [source](https://github.com/riverrun/argon2_elixir)\n* Bcrypt - bcrypt_elixir\n  * [docs](https://hexdocs.pm/bcrypt_elixir)\n  * [source](https://github.com/riverrun/bcrypt_elixir)\n* Pbkdf2 - pbkdf2_elixir\n  * [docs](https://hexdocs.pm/pbkdf2_elixir)\n  * [source](https://github.com/riverrun/pbkdf2_elixir)\n\nArgon2 is currently considered to be the strongest password hashing function,\nand it is the one we recommend.\n\nBcrypt and Pbkdf2 are viable alternatives, but they are less resistant than Argon2,\nto attacks using GPUs or dedicated hardware.","ref":"readme.html#password-hashing-libraries"},{"type":"extras","title":"Windows users - Comeonin","doc":"On Windows, it can be time-consuming and problematic to setup the environment needed\nto compile the C code in Argon2 and Bcrypt. For this reason, it is often easier to install\nPbkdf2, which has no C dependencies.\n\nFor more information, see\n[Choosing a library](https://github.com/riverrun/comeonin/wiki/Choosing-the-password-hashing-library).","ref":"readme.html#windows-users"},{"type":"extras","title":"Comeonin wiki - Comeonin","doc":"See the [Comeonin wiki](https://github.com/riverrun/comeonin/wiki) for more\ninformation on the following topics:\n\n* [Hashing passwords](https://github.com/riverrun/comeonin/wiki/Hashing-passwords) - a general guide to hashing passwords in your Elixir app\n* [Password hashing libraries](https://github.com/riverrun/comeonin/wiki/Choosing-the-password-hashing-library)\n* [Requirements](https://github.com/riverrun/comeonin/wiki/Requirements)\n* [Deployment](https://github.com/riverrun/comeonin/wiki/Deployment) - including information about using Docker\n* [References](https://github.com/riverrun/comeonin/wiki/References)","ref":"readme.html#comeonin-wiki"},{"type":"extras","title":"Contributing - Comeonin","doc":"There are many ways you can contribute to the development of Comeonin, including:\n\n* Reporting issues\n* Improving documentation\n* Sharing your experiences with others","ref":"readme.html#contributing"},{"type":"extras","title":"License - Comeonin","doc":"BSD. For full details, please read the LICENSE file.","ref":"readme.html#license"},{"type":"extras","title":"Upgrading to version 5","doc":"# Upgrading to version 5\n\nIn version 5 of Comeonin, in most cases, you will not call Comeonin directly,\nand so you will be able to remove it from your app.\n\nFollow the instructions below to upgrade:\n\n1. Remove `:comeonin` from the `deps` function in your mix.exs file.\n2. Update `:argon2_elixir` to version 2.0, `:bcrypt_elixir` to version 2.0,\nor `:pbkdf2_elixir` to version 1.0.\n3. Using the conversion tables below, edit the hashing functions.\n\n| Comeonin v4 | Comeonin v5 |\n| :---------- | :---------- |\n| Comeonin.Argon2.add_hash | Argon2.add_hash |\n| Comeonin.Argon2.check_pass | Argon2.check_pass |\n| Comeonin.Argon2.hashpwsalt | Argon2.hash_pwd_salt |\n| Comeonin.Argon2.checkpw | Argon2.verify_pass |\n| Comeonin.Argon2.dummy_checkpw | Argon2.no_user_verify |\n\n| Comeonin v4 | Comeonin v5 |\n| :---------- | :---------- |\n| Comeonin.Bcrypt.add_hash | Bcrypt.add_hash |\n| Comeonin.Bcrypt.check_pass | Bcrypt.check_pass |\n| Comeonin.Bcrypt.hashpwsalt | Bcrypt.hash_pwd_salt |\n| Comeonin.Bcrypt.checkpw | Bcrypt.verify_pass |\n| Comeonin.Bcrypt.dummy_checkpw | Bcrypt.no_user_verify |\n\n| Comeonin v4 | Comeonin v5 |\n| :---------- | :---------- |\n| Comeonin.Pbkdf2.add_hash | Pbkdf2.add_hash |\n| Comeonin.Pbkdf2.check_pass | Pbkdf2.check_pass |\n| Comeonin.Pbkdf2.hashpwsalt | Pbkdf2.hash_pwd_salt |\n| Comeonin.Pbkdf2.checkpw | Pbkdf2.verify_pass |\n| Comeonin.Pbkdf2.dummy_checkpw | Pbkdf2.no_user_verify |","ref":"upgrade_v5.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v5.5.0 (2024-10-04) - Changelog","doc":"* Changes\n  * Updated dependencies and made changes to silence warnings in Elixir 1.17","ref":"changelog.html#v5-5-0-2024-10-04"},{"type":"extras","title":"v5.4.0 - Changelog","doc":"* Changes\n  * Added deprecation warnings to add_hash and check_pass","ref":"changelog.html#v5-4-0"},{"type":"extras","title":"v5.3.3 - Changelog","doc":"* Changes\n  * updated documentation and README","ref":"changelog.html#v5-3-3"},{"type":"extras","title":"v5.3.0 - Changelog","doc":"* Changes\n  * changed `add_hash` so that it does NOT set the password to nil","ref":"changelog.html#v5-3-0"},{"type":"extras","title":"v5.2.0 - Changelog","doc":"* Enhancements\n  * updated documentation for the Comeonin module","ref":"changelog.html#v5-2-0"},{"type":"extras","title":"v5.1.0 - Changelog","doc":"* Enhancements\n  * add a behaviour_test module to be used by implementations of the Comeonin behaviours","ref":"changelog.html#v5-1-0"},{"type":"extras","title":"v5.0.0 - Changelog","doc":"* Enhancements\n  * updated Comeonin to be a specification for password hashing libraries\n    * it offers the Comeonin and Comeonin.PasswordHash behaviours","ref":"changelog.html#v5-0-0"},{"type":"extras","title":"v4.1.2 - Changelog","doc":"* Bug fixes\n  * made sure that the `hash_key` option is used if present","ref":"changelog.html#v4-1-2"},{"type":"extras","title":"v4.1.1 - Changelog","doc":"* Changes\n  * changed `check_pass` with statement to case - in an attempt to suppress dialyzer warnings","ref":"changelog.html#v4-1-1"},{"type":"extras","title":"v4.1.0 - Changelog","doc":"* Enhancements\n  * added `hash_key` option to `check_pass`\n    * as with version 4.0, `check_pass` will use `:password_hash` / `:encrypted_password` if present","ref":"changelog.html#v4-1-0"},{"type":"extras","title":"v4.0.0 - Changelog","doc":"* Enhancements\n  * Added support for Argon2 (as an optional dependency - argon2_elixir)\n  * Added higher-level helper functions to each algorithm's module\n    * These functions accept / return maps and should reduce code use when adding password hashes / checking passwords\n  * Improved the statistics function in each module - `report`\n* Changes\n  * Made all the hashing algorithms optional dependencies\n  * Moved the configuration to the separate dependency libraries\n  * Removed support for one-time passwords\n    * This is now a separate library - OneTimePassEcto (\"https://github.com/riverrun/one_time_pass_ecto\")","ref":"changelog.html#v4-0-0"},{"type":"extras","title":"v3.2.0 - Changelog","doc":"* Bug fixes\n  * Shortening user-supplied salts to 128 bits - making it compatible with other implementations","ref":"changelog.html#v3-2-0"},{"type":"extras","title":"v3.1.0 - Changelog","doc":"* Changes\n  * Now forcing a recompile of C code for Windows users","ref":"changelog.html#v3-1-0"},{"type":"extras","title":"v3.0.0 - Changelog","doc":"* Enhancements\n  * Small changes to NIF code to make it more scheduler-friendly\n  * Improved documentation with respect to Argon2\n* Changes\n  * Now using `elixir_make` to help compile the C code","ref":"changelog.html#v3-0-0"},{"type":"extras","title":"v2.6.0 - Changelog","doc":"* Enhancements\n  * Improved Windows build to prevent build failure when upgrading Erlang versions","ref":"changelog.html#v2-6-0"},{"type":"extras","title":"v2.4.0 - Changelog","doc":"* Enhancements\n  * Improved Windows build error messages\n* Changes\n  * Changed behavior for incorrect input to Bcrypt.gen_salt","ref":"changelog.html#v2-4-0"},{"type":"extras","title":"v2.3.0 - Changelog","doc":"* Enhancements\n  * Added support for one-time passwords (HOTP, TOTP) for use in two factor authentication","ref":"changelog.html#v2-3-0"},{"type":"extras","title":"v2.2.0 - Changelog","doc":"* Changes\n  * Improved documentation for Windows builds\n  * Updated the required Elixir version to 1.2","ref":"changelog.html#v2-2-0"},{"type":"extras","title":"v2.1.0 - Changelog","doc":"* Enhancements\n  * Added legacy option to Comeonin.Bcrypt.gen_salt so that hashes with the older $2a$ prefix can be more easily generated\n  * To try to solve the load errors after upgrading Erlang / Elixir:\n    * Force C code to be recompiled every time `deps.compile` is called\n    * Added basic upgrade function to the NIF library\n  * To be compatible with the nerves project:\n    * Added CROSSCOMPILE option to the Makefile\n    * Stopped the library autoloading on compilation (requires Elixir 1.2.2)","ref":"changelog.html#v2-1-0"},{"type":"extras","title":"v2.0.0 (2015-12-17) - Changelog","doc":"* Changes\n  * Increased the default number of rounds for pbkdf2_sha512 to 100_000\n  * Removed `create_hash` and `create_user` functions\n  * Moved the password strength checker and random password generator to a separate package, called NotQwerty123\n    * This means that i18n support has been moved to NotQwerty123","ref":"changelog.html#v2-0-0-2015-12-17"},{"type":"extras","title":"v1.6.0 (2015-11-17) - Changelog","doc":"* Changes\n  * Edited C code and deleted unused functions","ref":"changelog.html#v1-6-0-2015-11-17"},{"type":"extras","title":"v1.5.0 (2015-11-10) - Changelog","doc":"* Changes\n  * Moved gettext support to `comeonin_i18n` optional dependency\n  * Removed forced compilation of C code in dev and prod environments","ref":"changelog.html#v1-5-0-2015-11-10"},{"type":"extras","title":"v1.4.0 (2015-11-06) - Changelog","doc":"* Enhancements\n  * Added gettext support\n  * Added Japanese translations for messages","ref":"changelog.html#v1-4-0-2015-11-06"},{"type":"extras","title":"v1.3.0 (2015-10-18) - Changelog","doc":"* Enhancements\n  * Improved the efficiency of the common password check for the `strong_password` function\n  * Added more information to the Mix build errors\n* Changes\n  * Forcing compilation of C code in dev and prod environments","ref":"changelog.html#v1-3-0-2015-10-18"},{"type":"extras","title":"v1.2.0 (2015-09-26) - Changelog","doc":"* Enhancements\n  * Added a common option to the `strong_password` check. This checks for passwords that are easy to guess, or common\n  * Improved random password generator - added a check to ensure it is strong and set the minimum length to 8 characters","ref":"changelog.html#v1-2-0-2015-09-26"},{"type":"extras","title":"v1.1.4 (2015-09-25) - Changelog","doc":"* Bug fix\n  * Removed `random_bytes` function. Now calling :crypto.strong_rand_bytes directly","ref":"changelog.html#v1-1-4-2015-09-25"},{"type":"extras","title":"v1.1.0 (2015-07-28) - Changelog","doc":"* Changes\n  * Divided the `strong password` check into two parts: minimum length and check for punctuation\n  characters and digits\n  * Removed configuration values for password length for generated passwords and minimum length of passwords\n  for the password check","ref":"changelog.html#v1-1-0-2015-07-28"},{"type":"extras","title":"v1.0.5 (2015-07-14) - Changelog","doc":"* Bug fix\n  * Replaced `Mix.Shell.info` with `IO.binwrite` to prevent compile errors with certain character encodings","ref":"changelog.html#v1-0-5-2015-07-14"},{"type":"extras","title":"v1.0.1 (2015-05-31) - Changelog","doc":"* Enhancements\n  * Enabled the create_user function to be used with atoms as keys as well as strings","ref":"changelog.html#v1-0-1-2015-05-31"},{"type":"extras","title":"v1.0.0 (2015-05-20) - Changelog","doc":"* Changes\n  * Renamed signup_user, function to check password strength before hashing the password, to create_user\n* Enhancements\n  * Added create_user function which takes a map, removes the \"password\" entry and adds a \"password_hash\" entry","ref":"changelog.html#v1-0-0-2015-05-20"},{"type":"extras","title":"v0.11.0 (2015-05-19) - Changelog","doc":"* Changes\n  * Renamed hashpwsalt/2 to signup_user/1","ref":"changelog.html#v0-11-0-2015-05-19"},{"type":"extras","title":"v0.10.0 (2015-05-14) - Changelog","doc":"* Changes\n  * Removed log_rounds, or rounds, parameter for the function hashpwsalt\n  * Added option to check password (for strength) in the function hashpwsalt (hashpwsalt/2)","ref":"changelog.html#v0-10-0-2015-05-14"},{"type":"extras","title":"v0.9.0 (2015-05-08) - Changelog","doc":"* Enhancements\n  * Added random password generator\n  * Added optional check to test if passwords have digits and punctuation characters\n* Bug fixes\n  * Added information about password strength and password policies to the documentation","ref":"changelog.html#v0-9-0-2015-05-08"},{"type":"extras","title":"v0.8.2 (2015-05-02) - Changelog","doc":"* Bug fixes\n  * Updated Windows build and improved error information at compile time","ref":"changelog.html#v0-8-2-2015-05-02"},{"type":"extras","title":"v0.8.0 (2015-04-20) - Changelog","doc":"* Bug fixes\n  * Updated bcrypt to support non-ascii characters in the password (pbkdf2 already supports these characters)","ref":"changelog.html#v0-8-0-2015-04-20"},{"type":"extras","title":"v0.7.0 (2015-04-18) - Changelog","doc":"* Enhancements\n  * Use crypto.strong_rand_bytes by default for generating random numbers","ref":"changelog.html#v0-7-0-2015-04-18"},{"type":"extras","title":"v0.6.0 (2015-04-17) - Changelog","doc":"* Enhancements\n  * Updated bcrypt implementation to only call C functions for the most expensive operations","ref":"changelog.html#v0-6-0-2015-04-17"},{"type":"extras","title":"v0.5.0 (2015-04-14) - Changelog","doc":"* Enhancements\n  * Updated bcrypt implementation so that long-running NIFs are cut to a minimum","ref":"changelog.html#v0-5-0-2015-04-14"},{"type":"extras","title":"v0.4.0 (2015-04-05) - Changelog","doc":"* Enhancements\n  * Updated pbkdf2_sha512 to prevent users from calling `hashpass` without a salt","ref":"changelog.html#v0-4-0-2015-04-05"},{"type":"extras","title":"v0.3.0 (2015-03-04) - Changelog","doc":"* Enhancements\n  * Updated bcrypt to version 1.5.2","ref":"changelog.html#v0-3-0-2015-03-04"},{"type":"extras","title":"v0.2.4 (2015-02-26) - Changelog","doc":"* Enhancements\n  * Added configuration options for number of log_rounds, or rounds","ref":"changelog.html#v0-2-4-2015-02-26"},{"type":"extras","title":"v0.2.2 (2015-01-25) - Changelog","doc":"* Enhancements\n  * Improved documentation about the recommended time the functions should take\n  * Increased default number of rounds for pbkdf2_sha512 from 40000 to 60000\n  * Improved implementation of dummy check\n\n* Changes\n  * Removed the `salt_length` optional argument from `Comeonin.Pbkdf2.hashpwsalt`. The only optional argument to this function is now the number of rounds","ref":"changelog.html#v0-2-2-2015-01-25"},{"type":"extras","title":"v0.2.0 (2015-01-21) - Changelog","doc":"* Enhancements\n  * Added support for pbkdf2_sha512\n  * Added Travis integration\n  * Added timing functions to help developers adjust the complexity of the key derivation functions\n\n* Changes\n  * Removed the hashing and check functions from the main Comeonin module","ref":"changelog.html#v0-2-0-2015-01-21"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"* Bug fixes\n  * Enable build on OS X","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"* Bcrypt authentication","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}